diff --git a/deltarobot-vr/Assets/Meshes/arrow.dae.meta b/deltarobot-vr/Assets/Meshes/arrow.dae.meta
new file mode 100644
index 0000000..2a11f1a
--- /dev/null
+++ b/deltarobot-vr/Assets/Meshes/arrow.dae.meta
@@ -0,0 +1,102 @@
+fileFormatVersion: 2
+guid: 1ffbbc97c545f1646bc46cf25ff2c08a
+ModelImporter:
+  serializedVersion: 20200
+  internalIDToNameTable: []
+  externalObjects: {}
+  materials:
+    materialImportMode: 0
+    materialName: 0
+    materialSearch: 1
+    materialLocation: 1
+  animations:
+    legacyGenerateAnimations: 4
+    bakeSimulation: 0
+    resampleCurves: 1
+    optimizeGameObjects: 0
+    motionNodeName: 
+    rigImportErrors: 
+    rigImportWarnings: 
+    animationImportErrors: 
+    animationImportWarnings: 
+    animationRetargetingWarnings: 
+    animationDoRetargetingWarnings: 0
+    importAnimatedCustomProperties: 0
+    importConstraints: 0
+    animationCompression: 1
+    animationRotationError: 0.5
+    animationPositionError: 0.5
+    animationScaleError: 0.5
+    animationWrapMode: 0
+    extraExposedTransformPaths: []
+    extraUserProperties: []
+    clipAnimations: []
+    isReadable: 0
+  meshes:
+    lODScreenPercentages: []
+    globalScale: 1
+    meshCompression: 0
+    addColliders: 0
+    useSRGBMaterialColor: 1
+    sortHierarchyByName: 1
+    importVisibility: 1
+    importBlendShapes: 1
+    importCameras: 1
+    importLights: 1
+    fileIdsGeneration: 2
+    swapUVChannels: 0
+    generateSecondaryUV: 0
+    useFileUnits: 1
+    keepQuads: 0
+    weldVertices: 1
+    bakeAxisConversion: 0
+    preserveHierarchy: 0
+    skinWeightsMode: 0
+    maxBonesPerVertex: 4
+    minBoneWeight: 0.001
+    meshOptimizationFlags: -1
+    indexFormat: 0
+    secondaryUVAngleDistortion: 8
+    secondaryUVAreaDistortion: 15.000001
+    secondaryUVHardAngle: 88
+    secondaryUVMarginMethod: 1
+    secondaryUVMinLightmapResolution: 40
+    secondaryUVMinObjectScale: 1
+    secondaryUVPackMargin: 4
+    useFileScale: 1
+  tangentSpace:
+    normalSmoothAngle: 60
+    normalImportMode: 0
+    tangentImportMode: 3
+    normalCalculationMode: 4
+    legacyComputeAllNormalsFromSmoothingGroupsWhenMeshHasBlendShapes: 0
+    blendShapeNormalImportMode: 1
+    normalSmoothingSource: 0
+  referencedClips: []
+  importAnimation: 0
+  humanDescription:
+    serializedVersion: 3
+    human: []
+    skeleton: []
+    armTwist: 0.5
+    foreArmTwist: 0.5
+    upperLegTwist: 0.5
+    legTwist: 0.5
+    armStretch: 0.05
+    legStretch: 0.05
+    feetSpacing: 0
+    globalScale: 1
+    rootMotionBoneName: 
+    hasTranslationDoF: 0
+    hasExtraRoot: 0
+    skeletonHasParents: 1
+  lastHumanDescriptionAvatarSource: {instanceID: 0}
+  autoGenerateAvatarMappingIfUnspecified: 1
+  animationType: 0
+  humanoidOversampling: 1
+  avatarSetup: 0
+  addHumanoidExtraRootOnlyWhenUsingAvatar: 1
+  additionalBone: 0
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/Scenes/MainScene.unity b/deltarobot-vr/Assets/Scenes/MainScene.unity
index a706ed4..12c9446 100644
--- a/deltarobot-vr/Assets/Scenes/MainScene.unity
+++ b/deltarobot-vr/Assets/Scenes/MainScene.unity
@@ -162,7 +162,7 @@ LineRenderer:
   m_PrefabAsset: {fileID: 0}
   m_GameObject: {fileID: 67930113}
   m_Enabled: 1
-  m_CastShadows: 1
+  m_CastShadows: 2
   m_ReceiveShadows: 1
   m_DynamicOccludee: 1
   m_MotionVectors: 0
@@ -279,7 +279,7 @@ GameObject:
   - component: {fileID: 86918160}
   - component: {fileID: 86918159}
   m_Layer: 0
-  m_Name: DirArrow
+  m_Name: TargetDirection
   m_TagString: Untagged
   m_Icon: {fileID: 0}
   m_NavMeshLayer: 0
@@ -331,7 +331,7 @@ MeshRenderer:
   m_RenderingLayerMask: 1
   m_RendererPriority: 0
   m_Materials:
-  - {fileID: 2100000, guid: b01c4eddab52a9d47b02db54cc78e6c2, type: 2}
+  - {fileID: 2100000, guid: e2bc3c456e5936babaf6b4ec7434e213, type: 2}
   m_StaticBatchInfo:
     firstSubMesh: 0
     subMeshCount: 0
@@ -1066,7 +1066,7 @@ MeshRenderer:
   m_RenderingLayerMask: 1
   m_RendererPriority: 0
   m_Materials:
-  - {fileID: 2100000, guid: 62f2cab33e7d65346be49f4912bdd9ee, type: 2}
+  - {fileID: 2100000, guid: c14ddb25b53d5c1d38abd988a0ff268e, type: 2}
   m_StaticBatchInfo:
     firstSubMesh: 0
     subMeshCount: 0
@@ -1185,7 +1185,7 @@ GameObject:
   - component: {fileID: 1535691007}
   - component: {fileID: 1535691009}
   m_Layer: 0
-  m_Name: CurArrow
+  m_Name: ActualDirection
   m_TagString: Untagged
   m_Icon: {fileID: 0}
   m_NavMeshLayer: 0
@@ -1224,7 +1224,7 @@ MeshRenderer:
   m_RenderingLayerMask: 1
   m_RendererPriority: 0
   m_Materials:
-  - {fileID: 2100000, guid: ba5e94541fd24e84d8a7cef22c83d162, type: 2}
+  - {fileID: 2100000, guid: 306843c96e6ccc5e292e116d1d3418a6, type: 2}
   m_StaticBatchInfo:
     firstSubMesh: 0
     subMeshCount: 0
diff --git a/deltarobot-vr/obj.bak/Debug/Assembly-CSharp.csproj.CoreCompileInputs.cache b/deltarobot-vr/obj.bak/Debug/Assembly-CSharp.csproj.CoreCompileInputs.cache
new file mode 100644
index 0000000..13a8fbe
--- /dev/null
+++ b/deltarobot-vr/obj.bak/Debug/Assembly-CSharp.csproj.CoreCompileInputs.cache
@@ -0,0 +1 @@
+7b3914932a9465b83f1f994d4d09b947e6db2e26
diff --git a/deltarobot/curvedataserver.cpp b/deltarobot/curvedataserver.cpp
index b319547..51c1124 100644
--- a/deltarobot/curvedataserver.cpp
+++ b/deltarobot/curvedataserver.cpp
@@ -124,7 +124,6 @@ CurveDataServer::Client::Client(QTcpSocket* socket) :
 
 CurveDataServer::CurveDataServer() :
     _server(this),
-    _pingThread([this](){threadFunction();}),
     _sockets()
 {
     _server.listen(QHostAddress::Any, 4242);
@@ -139,8 +138,6 @@ CurveDataServer::~CurveDataServer()
         terminateConnection(client, "Server is stopping");
     }
     _sockets.clear();
-
-    _threadIsRunning = false;
 }
 
 void CurveDataServer::onNewConnection()
@@ -149,6 +146,7 @@ void CurveDataServer::onNewConnection()
     connect(clientSocket, SIGNAL(readyRead()), this, SLOT(onReadyRead()));
     connect(clientSocket, SIGNAL(stateChanged(QAbstractSocket::SocketState)), this, SLOT(onSocketStateChanged(QAbstractSocket::SocketState)));
 
+    qDebug() << "Client" << clientSocket->peerAddress() << "is connecting...";
     sendPreamble(clientSocket);
     _sockets.push_back(Client(clientSocket));
 }
@@ -268,15 +266,12 @@ void CurveDataServer::onReadyRead()
 void CurveDataServer::handleMessage(Client& client, uint16_t messageId, void *content, size_t contentSize) {
     switch (messageId) {
     case 0x3001:
-        qDebug() << "Magic arrived!";
         handleProtocolMagic(client, (char *) content);
         break;
     case 0x2002:
-        qDebug() << "Version arrived!";
         handleVersion(client, *((uint8_t*) content));
         break;
     case 0x3005:
-        qDebug() << "Pong " << *((uint64_t*) content) << " arrived!";
         handlePong(client, (uint64_t*) content);
         break;
     case 0xF006:
@@ -293,6 +288,7 @@ void CurveDataServer::handleProtocolMagic(Client& client, char *content)
     if (strncmp(content, correct, 8) == 0) {
         client.magic = true;
     }
+    validateProtocol(client);
 }
 
 void CurveDataServer::handleVersion(Client& client, uint8_t content)
@@ -301,6 +297,7 @@ void CurveDataServer::handleVersion(Client& client, uint8_t content)
     {
         client.version = true;
     }
+    validateProtocol(client);
 }
 
 void CurveDataServer::handlePong(Client& client, uint64_t* content)
@@ -316,7 +313,6 @@ void CurveDataServer::handlePong(Client& client, uint64_t* content)
 
     client.latency = time - timeSent;
     client.lastPong = time;
-    //qDebug() << "prisel pong" << number;
 }
 
 void CurveDataServer::handleEOT(Client& client, char* content, size_t contentSize)
@@ -325,11 +321,19 @@ void CurveDataServer::handleEOT(Client& client, char* content, size_t contentSiz
     std::memcpy(cstrContent, content, contentSize);
     cstrContent[contentSize] = '\0';
 
-    qDebug() << "Client" << client.socket->peerName() << "disconnected:" << cstrContent;
+    qDebug() << "Client" << client.socket->peerAddress() << "disconnected:" << cstrContent;
     terminateConnection(client, "Recieved EOT from client");
 }
 
 
+void CurveDataServer::validateProtocol(Client &client) {
+    if (!client.protocolValid && client.magic && client.version) {
+        client.protocolValid = true;
+        qDebug() << "Client" << client.socket->peerAddress() << "has successfully connected.";
+    }
+}
+
+
 void CurveDataServer::terminateConnection(Client& client, std::string&& reason)
 {
     if (client.socket->isOpen())
@@ -339,6 +343,7 @@ void CurveDataServer::terminateConnection(Client& client, std::string&& reason)
         client.socket->close();
     }
 
+    qDebug() << "Terminating connection to client" << client.socket->peerAddress() << "reason:" << reason.c_str();
     removeSocket(client.socket);
 }
 
@@ -450,8 +455,6 @@ void CurveDataServer::sendProtocolMagic(QTcpSocket *socket)
     QByteArray message = message64(0x3001, *((uint64_t*) messageContent));
 
     socket->write(message);
-
-    qDebug() << "Sent Protocol Magic to" << socket->peerAddress();
 }
 
 void CurveDataServer::sendVersion(QTcpSocket *socket)
@@ -459,8 +462,6 @@ void CurveDataServer::sendVersion(QTcpSocket *socket)
     QByteArray message = message32(0x2002, 1);
 
     socket->write(message);
-
-    qDebug() << "Sent Protocol Version to" << socket->peerAddress();
 }
 
 void CurveDataServer::sendEot(QTcpSocket *socket, std::string&& reason)
@@ -469,37 +470,23 @@ void CurveDataServer::sendEot(QTcpSocket *socket, std::string&& reason)
     socket->write(message);
 }
 
-
-
 void CurveDataServer::sendMessageToAllConnected(QByteArray &message)
 {
     std::lock_guard<decltype (_socketsLock)> l(_socketsLock);
     for (auto& client : _sockets) {
-        if (client.magic && client.version)
+        if (client.protocolValid)
         {
             client.socket->write(message);
         }
     }
 }
 
-void CurveDataServer::threadFunction()
-{
-    while (_threadIsRunning)
-    {
-        //processPings();
-
-        // TODO tim se zpravilo varovani se socketama
-
-        std::this_thread::sleep_for(std::chrono::milliseconds(100));
-    }
-}
-
 void CurveDataServer::processPings()
 {
     std::lock_guard<decltype (_socketsLock)> l(_socketsLock);
     for (auto& client : _sockets) {
 
-        if (client.magic && client.version)
+        if (client.protocolValid)
         {
             if (client.lastPong  < currentTimeMillis() - 10000)
             {
@@ -539,10 +526,7 @@ void CurveDataServer::sendPing(Client& client)
 {
     uint64_t number = (((uint64_t) rand()) << 32) + (uint64_t) rand();
 
-    //qDebug() << "posilam ping" << ((qint64) number) << ".";
-
     client.ping.emplace(std::make_pair(number, currentTimeMillis()));
-    //client.ping.insert({number, currentTimeMillis()});
 
     client.socket->write(message64(0x3004, (uint64_t) number));
 }
diff --git a/deltarobot/curvedataserver.h b/deltarobot/curvedataserver.h
index e530da1..586bae0 100644
--- a/deltarobot/curvedataserver.h
+++ b/deltarobot/curvedataserver.h
@@ -8,11 +8,21 @@
 #include <mutex>
 #include <thread>
 
+
+/**
+ * Manages communication with clients who can connect to the server in order to receive real-time data about the current
+ * exercise. The served data may be used e.g. for external visualization. A reference implementation of such a client is
+ * the deltarobot-vr Unity application.
+ */
 class CurveDataServer : QObject
 {
     Q_OBJECT
 
 public:
+
+    /**
+     * Holds information about a client, its Qt socket, data buffer etc.
+     */
     struct Client {
         /**
          * Size of the client buffer.
@@ -21,20 +31,22 @@ public:
          */
         static const size_t BUF_SIZE = 4096;
 
-        static const size_t MESSAGE_ID_SIZE = sizeof(uint16_t);      ///< Size of the protocol message identifier.
-        static const size_t MESSAGE_LENGTH_SIZE = sizeof(uint32_t);  ///< Size of the variable-length message's content length.
+        static const size_t MESSAGE_ID_SIZE = sizeof(uint16_t);      ///< Size of the protocol message identifier
+        static const size_t MESSAGE_LENGTH_SIZE = sizeof(uint32_t);  ///< Size of the variable-length message's content length
+
+        QTcpSocket* socket;                 ///< Communication socket
+        std::map<uint64_t, uint64_t> ping;  ///< Key: ping ID;  Value: ping timestamp (msec);
+        uint64_t latency;                   ///< Current latency
+        uint64_t lastPong;                  ///< Timestamp of the last pong
 
-        QTcpSocket* socket;
-        std::map<uint64_t, uint64_t> ping;  ///< key: ping ID;  value: ping timestamp (msec);
-        uint64_t latency;               ///< client's latency
-        uint64_t lastPong;              ///< timestamp of last pong
+        char buf[BUF_SIZE];                 ///< Message buffer
+        size_t bufUsed = 0;                 ///< Number of bytes used up in the message buffer
 
-        char buf[BUF_SIZE];
-        size_t bufUsed;
+        bool magic = false;                 ///< Whether the client has sent the correct protocol magic
+        bool version = false;               ///< Whether the client has sent the correct protocol version
+        bool protocolValid = false;         ///< Whether the client has sent both the correct protocol magic and version.
 
-        bool magic = false;
-        bool version = false;
-        bool initialized = false;
+        bool initialized = false;           ///< Whether the server has initialized this client with the current curve
 
         Client(QTcpSocket* socket);
     };
@@ -42,14 +54,26 @@ public:
     explicit CurveDataServer();
     ~CurveDataServer();
 
+    /** Sends the current actuator position. */
     void sendActuatorPosition(float x, float y, float z);
+
+    /** Sends the actual direction the actuator is moving in. */
     void sendActualDirection(float x, float y, float z);
+
+    /** Sends the direction the actuator *should* be moving in, in order to draw the curve. */
     void sendTargetDirection(float x, float y, float z);
+
+    /** Stores and sends the specified curve. */
     void sendNewCurve(QList<QVector4D> &points);
+
+    /** Stores and sends the specified curve. */
     void sendNewCurve(QList<QVector3D> &points);
+
+    /** Sends the currently stored curve. This is used for newly connected clients. */
     void sendCurve(Client &client);
 
-    void processPings();            ///< send pings, check timeouts
+    /** Sends ping messages to the clients, checks whether any clients have timed out, and disconnects any that have. */
+    void processPings();
 
 public slots:
     void onNewConnection();
@@ -57,6 +81,7 @@ public slots:
     void onReadyRead();
 
 private:
+    /** Gets the client that is connected via the specified socket. */
     QList<Client>::iterator clientOf(QTcpSocket *socket);
 
     void handleMessage(Client& client, uint16_t messageId, void* content, size_t contentSize);
@@ -65,7 +90,12 @@ private:
     void handlePong(Client& client, uint64_t* content);
     void handleEOT(Client& client, char* content, size_t contentSize);
 
-    void validPreamble(Client& client);
+    /**
+     * Checks whether the specified client has already sent both its protocol magic and version. If so, the appropriate
+     * flag is set and a log is written out into qDebug.
+     */
+    void validateProtocol(Client& client);
+
     void removeSocket(QTcpSocket *socket);
     void terminateConnection(Client& client, std::string&& reason);
     void sendPing(Client& client);
@@ -77,12 +107,7 @@ private:
 
     void sendMessageToAllConnected(QByteArray &message);
 
-    void threadFunction();
-
     QTcpServer _server;
-    std::thread _pingThread;
-
-    volatile bool _threadIsRunning = true;
 
     std::recursive_mutex _socketsLock;
     QList<Client> _sockets;
